# GitLab CI Docker Image
image: node:5.9.1

# Build - Build necessary JS files
# Test - Run tests
# Deploy - Deploy application to S3/ElasticBeanstalk
stages:
  - build
  - test
  - deploy

# Configuration
variables:
  AWS_DEFAULT_REGION: "ap-south-1" # Or, wherever you are
  S3_BUCKET: "" # S3 bucket for ElasticBeanstalk
  S3_KEY: "" # S3 folder to upload built app

# Job: Build
# Installs npm packages, transpiles ES6 -> ES5
# Passes node_modules/, dist/ onto next steps using artifacts
build:
  stage: build
  script:
    - npm install
    - ./bin/build
  artifacts:
    paths:
      - node_modules/
      - dist/
  tags:
    - nodejs-app

# Job: Test
# Run tests against our application
# If this fails, we do not deploy
test:
  stage: test
  script:
    - ./bin/test
  tags:
    - nodejs-app

# Job: Deploy
# Zips the contents of our built application, uploads to S3
# Configures a new EB version and switches to that version
deploy:
  stage: deploy
  script:
    - ./deploy.sh
  tags:
    - nodejs-app